REM INSERTING into VAP.MAIL_TEMPLATE
SET DEFINE OFF;
SET SQLBLANKLINES ON

INSERT INTO VAP.MAIL_TEMPLATE (MAIL_TEMPLATE_ID, LETTER_TYPE_ID, TEXT) VALUES (1, 1, 'DEPARTMENT OF VETERANS AFFAIRS
[facilityName]
[facilityAddress1]
[facilityAddress2]
[facilityPhone]

[date]

[lastName], [firstName] [middleName]
[patientAddress]

Dear [firstName],

Thank you for participating in the Virtual Lifetime Electronic Record (VLER) Program part of Veteran Health Information Exchange (VHIE). Based on the information you provided via VA Form 10-0484, you wish to revoke the ability for the Department of Veterans Affairs (VA) to share your medical information between your VA health care team(s) and your participating community care providers.

This letter is to notify you that your revocation form has been accepted, and VA stopped sharing your electronic health information with your community health care provider organizations effective [expirationDate].

If you decide to re-enroll in the VLER Program as part of Veterans Health Information Exchange (VHIE) and have your electronic health information shared at a later date, you may do so by visiting the VLER Health website at http://www.va.gov/VLER/vler-health-exchange-registration-guide.asp#online. Or contact your Release of Information (ROI) Office at your local VA Medical Center.

Thank you for allowing us to serve you and for your service to our Nation!

Sincerely,

[signature]');

INSERT INTO VAP.MAIL_TEMPLATE (MAIL_TEMPLATE_ID, LETTER_TYPE_ID, TEXT) VALUES (2, 2, 'DEPARTMENT OF VETERANS AFFAIRS
[facilityName]
[facilityAddress1]
[facilityAddress2]
[facilityPhone]

[date]

[lastName], [firstName] [middleName]
[patientAddress]

Dear [firstName],

Thank you for participating in the Virtual Lifetime Electronic Record (VLER) Program part of Veteran Health Information Exchange (VHIE). VA is pleased that you have opted to share your medical information between your Veterans Affairs (VA) health care team(s) and your participating community care providers. In order to provide you with continuity of care, VA must have a signed written authorization on file for your participation in VHIE. This letter is to notify you that authorization is required at this time in order to allow VA to share your health information.

Delayed Authorization Status:

            Original Entry Date: [entryDate]
            Status: PENDING
            Reason: [reasonsForDelay]

A VA Form 10-0485 (Authorization to Share), has been included for you to provide your authorization.  You can provide your authorization by mailing a signed form back to the Release of Information (ROI) Office at your local VA Medical Center (identified above) or online by using eBenefits and following the instructions at http://www.va.gov/VLER/vler-health-exchange-registration-guide.asp#online.

For additional information on sharing your health record, please visit the VLER Health website at www.va.gov/vler.  You can also call your local VA Medical Center’s (ROI) Office for more details.

Thank you for allowing us to serve you and for your service to our Nation!

Sincerely,

[signature]');

INSERT INTO VAP.MAIL_TEMPLATE (MAIL_TEMPLATE_ID, LETTER_TYPE_ID, TEXT) VALUES (3, 3, 'DEPARTMENT OF VETERANS AFFAIRS
[facilityName]
[facilityAddress1]
[facilityAddress2]
[facilityPhone]

[date]

[lastName], [firstName] [middleName]
[patientAddress]

Dear [firstName],

Thank you for participating in the Virtual Lifetime Electronic Record (VLER)/Veteran Health Information Exchange (VHIE).  We are pleased that you have opted to share your health information between the Department of Veterans Affairs (VA) and your community care providers.  In order to provide you with better continuity of care, the VA must have a valid written authorization on file. This letter is to notify you that one or more items are needed to provide VA with permission to share your health information.  The sharing of your health information is being delayed pending the receipt of additional information noted below.

Form In Delayed Status:

            Type of Form: Delayed SSA Authorization
            Purpose: TREATMENT
            Authorization/Revocation: Authorized access to Providers and Organizations
            Entry Date: [entryDate]
            Status: PENDING
            Reason: [reasonsForDelay]

If you have questions about the delayed form or the process for supplying the additional information, please contact the Release of Information (ROI) Office at your local VA Medical Center. The VA Form 10-0485 can also be completed online, by mail, or submitted in person at the Release of Information (ROI) Office at your local VA Medical Center. Once we have the information required, we can begin sharing your health information.

Thank you for allowing us to serve you and Your Service to Our Nation!

Sincerely,

[signature]');

INSERT INTO VAP.MAIL_TEMPLATE (MAIL_TEMPLATE_ID, LETTER_TYPE_ID, TEXT) VALUES (4, 4, 'DEPARTMENT OF VETERANS AFFAIRS
[facilityName]
[facilityAddress1]
[facilityAddress2]
[facilityPhone]

[date]

[lastName], [firstName] [middleName]
[patientAddress]

Dear [firstName],

Thank you for participating in the Virtual Lifetime Electronic Record Program (VLER), the Veteran Health Information Exchange (VHIE). VA is pleased that you have opted to share your health information between your Veterans Affairs (VA) health care team(s) and your participating community care providers.  In order to provide you with continuity of care, VA must have a current written and signed authorization on file. This letter is to notify you that your authorization is either going to expire soon or has already expired and a new authorization form is needed to allow VA to continue to share your health information.

            Expiration Date: [expirationDate]

For instructions on how to renew your soon to expire or expired authorization, please visit the Release of Information (ROI) Office at your local VA Medical Center (identified in the header above), submit by mail, or renew online through eBenefits at www.va.gov/vler.

Thank you for allowing us to serve you and for your service to our Nation!

Sincerely,

[signature]');

SET SQLBLANKLINES OFF
COMMIT;
