CREATE TABLE VAP.FACILITY
(
  FACILITY_ID           NUMBER                  NOT NULL,
  FACILITY_STATION      VARCHAR2(20 BYTE),
  FACILITY_DNS          VARCHAR2(255 BYTE),
  FACILITY_NAME         VARCHAR2(1024 BYTE),
  ALLOWED               NUMBER                  NOT NULL,
  VISN_ID               NUMBER,
  FACILITY_PHONE        VARCHAR2(100 BYTE),
  FACILITY_ADDRESS      VARCHAR2(200 BYTE),
  FACILITY_CITY         VARCHAR2(100 BYTE),
  FACILITY_STATE        VARCHAR2(20 BYTE),
  FACILITY_POSTAL_CODE  VARCHAR2(20 BYTE),
  FACILITY_PARENT       VARCHAR2(20 BYTE),
  ACTIVE                VARCHAR2(20 BYTE)
);


CREATE INDEX VAP.FACILITY_IDX ON VAP.FACILITY
(FACILITY_STATION, FACILITY_DNS);

CREATE UNIQUE INDEX VAP.FACILITY_PK ON VAP.FACILITY
(FACILITY_ID);

CREATE INDEX VAP.IDX_F_FACILITY_NAME ON VAP.FACILITY
(FACILITY_NAME);

CREATE INDEX VAP.IDX_F_FACILITY_STATION ON VAP.FACILITY
(FACILITY_STATION);

ALTER TABLE VAP.FACILITY ADD (
  CONSTRAINT FACILITY_PK
  PRIMARY KEY
  (FACILITY_ID)
  USING INDEX VAP.FACILITY_PK
  ENABLE VALIDATE);

ALTER TABLE VAP.FACILITY ADD (
  CONSTRAINT IDX_F_FACILITY_STATION
  UNIQUE (FACILITY_STATION)
  USING INDEX VAP.FACILITY_IDX
  ENABLE VALIDATE);
