CREATE TABLE VAP.SCHEDULE
(
  SCHEDULE_ID  NUMBER                           NOT NULL,
  EVENT_DATE   DATE                             NOT NULL,
  TYPE         VARCHAR2(20 BYTE)                NOT NULL
);


CREATE UNIQUE INDEX VAP.SCHEDULER_PK ON VAP.SCHEDULE
(SCHEDULE_ID);

CREATE UNIQUE INDEX VAP.SCHEDULE_UK1 ON VAP.SCHEDULE
(EVENT_DATE, TYPE);

ALTER TABLE VAP.SCHEDULE ADD (
  CONSTRAINT SCHEDULER_PK
  PRIMARY KEY
  (SCHEDULE_ID)
  USING INDEX VAP.SCHEDULER_PK
  ENABLE VALIDATE);

ALTER TABLE VAP.SCHEDULE ADD (
  CONSTRAINT SCHEDULE_UK1
  UNIQUE (EVENT_DATE, TYPE)
  USING INDEX VAP.SCHEDULE_UK1
  ENABLE VALIDATE);
