#!/bin/bash
echo "Enter Environment Name:"
read OLD
echo "Enter New Version:"
read NEW

# Just a backup.
cp -p nvap-ea-$NEW.ear nvap-ea-$NEW.ear.bak

# Grabs WAR file from the new ear.
unzip -j "nvap-ea-$NEW.ear" "nvap-web-$NEW.war" 

# Removes properties from the WAR file that was in the new EAR.
zip -d nvap-web-$NEW.war "WEB-INF/classes/gov/va/nvap/web/endpoints.properties"
zip -d nvap-web-$NEW.war "WEB-INF/classes/web.properties"

# Copies over properties files from environment config file directory tree into working dir subpath.
mkdir -p WEB-INF/classes/gov/va/nvap/web/
cp nvap-$OLD/nvap-web-$OLD/WEB-INF/classes/gov/va/nvap/web/endpoints.properties WEB-INF/classes/gov/va/nvap/web/
cp nvap-$OLD/nvap-web-$OLD/WEB-INF/classes/web.properties WEB-INF/classes/

# Updates new WAR with properties files copied over from environment config file directory tree.
zip -A nvap-web-$NEW.war "WEB-INF/classes/gov/va/nvap/web/endpoints.properties"
zip -A nvap-web-$NEW.war "WEB-INF/classes/web.properties"

# Updates WAR inside of new EAR.
zip -d nvap-ea-$NEW.ear nvap-web-$NEW.war 
zip -A nvap-ea-$NEW.ear nvap-web-$NEW.war

# Cleans up WAR and WEB-INF that were made in working directory.
rm -rf WEB-INF
rm nvap-web-$NEW.war

# Grabs nvap-client library jar from new EAR.
unzip -j "nvap-ea-$NEW.ear"   "APP-INF/lib/nvap-client-$NEW.jar"

# Deletes properties from working nvap-client jar.
zip -d "nvap-client-$NEW.jar" "META-INF/direct.properties" 

# Copies over properties from environment config file directory tree.
mkdir META-INF
cp nvap-$OLD/APP-INF/lib/nvap-client-$OLD/META-INF/direct.properties META-INF

# Adds properties copied from environment config file directory tree into working nvap-client jar.
zip -A "nvap-client-$NEW.jar" "META-INF/direct.properties"

# Moves working nvap-client jar into correct sub-path in working directory.
mkdir -p "APP-INF/lib/"
mv nvap-client-$NEW.jar APP-INF/lib/

# Updates nvap-client inside new EAR.
zip -d nvap-ea-$NEW.ear "APP-INF/lib/nvap-client-$NEW.jar"
zip -A nvap-ea-$NEW.ear "APP-INF/lib/nvap-client-$NEW.jar"

# Cleanup.
rm -r META-INF
rm -r APP-INF

# Copies every file at root of nvap-server (just a few extra) in environment config file directory tree.
cp nvap-$OLD/nvap-server-$OLD/* .

# Grabs nvap-server EJB JAR from new EAR.
unzip -j "nvap-ea-$NEW.ear" "nvap-server-$NEW.jar" 

# Adds properties copied from environment config file directory tree into working nvap-server EJB JAR.
zip -d nvap-server-$NEW.jar server.properties
zip -A nvap-server-$NEW.jar server.properties
zip -d nvap-server-$NEW.jar email.properties
zip -A nvap-server-$NEW.jar email.properties
zip -d nvap-server-$NEW.jar beanRefContext.xml
zip -A nvap-server-$NEW.jar beanRefContext.xml

# Updates the new EAR with the updated nvap-server EJB JAR.
zip -d nvap-ea-$NEW.ear nvap-server-$NEW.jar 
zip -A nvap-ea-$NEW.ear nvap-server-$NEW.jar

# Cleanup
rm nvap-server-$NEW.jar	server.properties email.properties beanRefContext.xml

# Update new EAR's LOG4J Properties with one from environment config file directory tree.
zip -d nvap-ea-$NEW.ear "APP-INF/classes/log4j.xml"
pushd nvap-$OLD
zip -A ../nvap-ea-$NEW.ear "APP-INF/classes/log4j.xml"
popd

