CREATE TABLE "VAP"."VISN" (
    "ID"    NUMBER NOT NULL,
    "VISN_NUMBER"   NUMBER NOT NULL,
    "VISN_NAME" VARCHAR2(255) NOT NULL,
    constraint  "VISN_PK" primary key ("ID")
    ENABLE 
);

INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (1, 1, 'VISN 1 - VA New England Healthcare System');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (2, 2, 'VISN 2 - VA Healthcare Network Upstate New York');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (3, 3, 'VISN 3 - VA NY/NJ Veterans Healthcare Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (4, 4, 'VISN 4 - VA Healthcare - VISN4');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (5, 5, 'VISN 5 - VA Capitol Health Care Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (6, 6, 'VISN 6 - VA Mid-Atlantic Health Care Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (7, 7, 'VISN 7 - VA Southeast Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (8, 8, 'VISN 8 - VA Sunshine Healthcare Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (9, 9, 'VISN 9 - VA Mid South Healthcare Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (10, 10, 'VISN 10 - VA Healthcare System of Ohio');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (11, 11, 'VISN 11 - Veterans In Partnership');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (12, 12, 'VISN 12 - The Great Lakes Health Care System');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (15, 15, 'VISN 15 - Heartland Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (16, 16, 'VISN 16 - South Central VA Health Care Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (17, 17, 'VISN 17 - VA Heart of Texas Health Care Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (18, 18, 'VISN 18 - VA Southwest Health Care Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (19, 19, 'VISN 19 - Rocky Mountain Network ');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (20, 20, 'VISN 20 - Northwest Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (21, 21, 'VISN 21 - Sierra Pacific Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (22, 22, 'VISN 22 - Desert Pacific Healthcare Network');
INSERT INTO VAP.VISN (ID, VISN_NUMBER, VISN_NAME) VALUES (23, 23, 'VISN 23 - VA Midwest Health Care Network');

ALTER TABLE "VAP"."FACILITY"
ADD VISN_ID NUMBER;

ALTER TABLE "VAP"."FACILITY" ADD CONSTRAINT "VISN_ID_FK"
FOREIGN KEY ("VISN_ID")
REFERENCES "VAP"."VISN" ("ID");

CREATE OR REPLACE SYNONYM VAP_APP.VISN FOR VAP.VISN;
GRANT SELECT ON VAP.VISN TO VAP_USER;
GRANT SELECT ON VAP.VISN TO VAP_READ;
