/**
 *
 * 
 */
package gov.va.nvap.server.endpoint.dataquality;

import gov.va.nvap.service.audit.AuditException;
import gov.va.nvap.service.dataquality.DqTransmissionLogManager;
import gov.va.nvap.service.dataquality.DqTransmissionLogQueryRequest;

import javax.ejb.Stateless;
import javax.interceptor.Interceptors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.ejb.interceptor.SpringBeanAutowiringInterceptor;

/**
 * Wraps the DqTransmissionLogServiceEndpoint Spring REST client class, 
 * so it looks like an EJB to nvap-web. Can't include nvap-server directly in 
 * nvap-web, so had to use the existing way of doing things, even
 * with Spring and REST.
 * 
 */
@Stateless(name = "DqTransmissionLogManager", mappedName = "DqTransmissionLogManager")
@javax.ejb.Remote(DqTransmissionLogManager.class)
@Interceptors(SpringBeanAutowiringInterceptor.class)
public class DqTransmissionLogServiceFacade implements DqTransmissionLogManager {

    @Autowired
    @Qualifier(value = "dqTransmissionLogServiceEndpoint")
    DqTransmissionLogManager dqTransmissionLogServiceEndpoint;    

    @Override
    public String getDqTransmissionLogData(DqTransmissionLogQueryRequest logQueryRequest) throws AuditException {
        return this.dqTransmissionLogServiceEndpoint.getDqTransmissionLogData(logQueryRequest);
    }    

    public void setDqTransmissionLogServiceEndpoint(DqTransmissionLogManager dqTransmissionLogServiceEndpoint) {
        this.dqTransmissionLogServiceEndpoint = dqTransmissionLogServiceEndpoint;
    }        
    
}
