<%-- 
    Document   : calendarValidationHelper
    Created on : Jan 9, 2018, 6:41:40 AM
    Author     : Johann P. Sonnenberg
--%>

<%@tag description="This tag is used to override the error on the isValidDateMMDDYYYY and required for the date IF we are on the calendar icon next to it. This DOES NOT negate the form validation when clicking the Submit button. This tag should be called in the document ready within <script> tags." pageEncoding="UTF-8"%>

<%@attribute name="elementsToRemoveErrorClassesOn" description="a comma separated list of DOM elements to remove the has-error and has-danger classes on. These are usually the input itself and the surrounding form-group div." required="true" %>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@tag import="java.util.*"%>

<%
    List<String> elements = Arrays.asList(elementsToRemoveErrorClassesOn.split("\\s*(,\\s*)+"));
    
    pageContext.setAttribute("elements", elements);
%>

<%-- any content can be specified here e.g.: --%>
$(document).on('validated.bs.validator', function(){
    var targetsClass = $(event.relatedTarget).attr('class');

    if(targetsClass != null) {

        if(targetsClass.indexOf('datepicker-button') >= 0) {
            <c:forEach var="element" items="${elements}">
                $('#<c:out value="${element}" escapeXml="true" />').removeClass('has-error has-danger');
            </c:forEach>
            event.preventDefault();
        }
    }
});