<%-- 
    Document   : viewFacility
    Created on : Jan 9, 2017, 12:22:21 PM
    Author     : Raul Alfaro
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>

<f:mainTemplate headerText="${empty results.stationNumber ? 'Add Facility' : 'Edit Facility'}">
    
    <script type="text/javascript">
        $(document).ready(function () {
            prepareRelationships();
            
            $('#confirmInactivateModalInactivate').on('click', function(){
                var stationNumber = '<c:out value="${results.stationNumber}"/>';
                location.href = 'EditFacility.do_sec?inactivateFacility=true&stationNumber=' + stationNumber;  
            });
            
            $('#parent').change(function () {
                updateInactivateButton();
            });
        });

        prepareRelationships = function() {
            var children = '<c:out value="${results.children}"/>';
            var parent = '<c:out value="${results.parent}"/>';
            var endResult = '';

            if (parent === 'None' && children !== 'None') {
                $('#parentSection').hide();
                var kids = children.split('|');
                $.each(kids, function (index, value) {
                    endResult = endResult + '<a href="#/" onclick="editStation(parseStationNumber(\'' + value + '\'));">' + value + '</a><br>';
                });
                $('#children').html(endResult);
            } else {
                $('#kidsSection').hide();
            }
            
            updateInactivateButton();
        };

        parseStationNumber = function(fullName) {
            var stationNumberRegex = /(\d{3}(\w{1,2})?)(?=\)$)/g;

            return stationNumberRegex.exec(fullName)[0];
        };

        editStation = function(stationNumber) {
            location.href = 'EditFacility.do_sec?stationNumber=' + stationNumber;
        };
        
        inactivateStation = function(event) {
            $('#confirmInactivateModal').modal('show');
        };
        
        updateInactivateButton = function(){
            if ($('#parent').val() === '' && $('#children').children().length === 0) {
                $('#btnInactivate').removeAttr('disabled');
            } else {
                $('#btnInactivate').prop('disabled', 'disabled');
            }
        };
        
    </script>

    <cpp:errors/>

    <div>
        <form class="form-horizontal" name="editFacilityForm" id="editFacilityForm" action="EditFacility.do_sec?saveEdit=true" method="post" data-toggle="validator" role="form">
            <div id="errorMessage" class="alert alert-danger" style="display: none;" role="alert"></div>
            <input hidden name="originalStationNumber" id="originalStationNumber" value="<c:out value="${results.stationNumber}"/>"/>
            <div class="form-group">
                <label for="stationNumber" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Station Number is a required field." labelText="Station Number" /></label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">    
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityStationNumber']}"/>" type="text" name="stationNumber" id="stationNumber" maxlength="255" value="<c:out value="${results.stationNumber}"/>" required /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityStationNumber']}"/>" type="text" name="stationNumber" id="stationNumber" maxlength="255" value="<c:out value="${results.stationNumber}"/>" required />
                </div>
            </div>
            <div class="form-group">
                <label for="facilityName" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Facility Name is a required field." labelText="Facility Name" /></label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">    
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityName']}"/>" type="text" name="facilityName" id="facilityName" maxlength="255" value="<c:out value="${results.facilityName}"/>" required /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityName']}"/>" type="text" name="facilityName" id="facilityName" maxlength="255" value="<c:out value="${results.facilityName}"/>" required />
                </div>
            </div>
            <div class="form-group">
                <label for="facilityDNS" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Facility DNS</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">    
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityDNS']}"/>" type="text" name="facilityDNS" id="facilityDNS" maxlength="255" value="<c:out value="${results.facilityDNS}"/>"/> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityDNS']}"/>" type="text" name="facilityDNS" id="facilityDNS" maxlength="255" value="<c:out value="${results.facilityDNS}"/>"/>
                </div>
            </div>
            <div class="form-group">
                <label for="address" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Address</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityAddress']}"/>" type="text" name="address" id="address" maxlength="255" value="<c:out value="${results.address}"/>" /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityAddress']}"/>" type="text" name="address" id="address" maxlength="255" value="<c:out value="${results.address}"/>" />
                </div>
            </div>
            <div class="form-group">
                <label for="city" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">City</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityCity']}"/>" type="text" name="city" id="city" maxlength="255" value="<c:out value="${results.city}"/>" /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityCity']}"/>" type="text" name="city" id="city" maxlength="255" value="<c:out value="${results.city}"/>" />
                </div>
            </div>
            <div class="form-group">
                <label for="state" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">State</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityState']}"/>" type="text" name="state" id="state" maxlength="2" value="<c:out value="${results.state}"/>" /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityState']}"/>" type="text" name="state" id="state" maxlength="2" value="<c:out value="${results.state}"/>" />
                </div>
            </div>
            <div class="form-group">
                <label for="zipCode" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Zip Code</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityZipCode']}"/>" type="text" name="zipCode" id="zipCode" maxlength="10" value="<c:out value="${results.zipCode}"/>" /> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityZipCode']}"/>" type="text" name="zipCode" id="zipCode" maxlength="10" value="<c:out value="${results.zipCode}"/>" />
                </div>
            </div>
            <div class="form-group">
                <label for="phoneNumber" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Phone Number</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <%-- <input class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityPhoneNumber']}"/>" type="text" name="phoneNumber" id="phoneNumber" maxlength="10" value="<c:out value="${results.phoneNumber}"/>"/> --%>
                    <input class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityPhoneNumber']}"/>" type="text" name="phoneNumber" id="phoneNumber" maxlength="10" value="<c:out value="${results.phoneNumber}"/>"/>
                </div>
            </div>
            <div class="form-group">
                <label for="visn" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="VISN is a required field." labelText="VISN" /></label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <span id="visnSpan">
                        <%-- <select class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityVisn']}"/>" name="visn" id="visn" > --%>
                        <select class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityVisn']}"/>" name="visn" id="visn" required>
                            <c:forEach items="${results.visnList}" var="current">
                                <option value="${current.visnNumber}" <c:if test="${results.visnId == current.visnNumber}">selected</c:if>>${current.visnName}</option>
                            </c:forEach>
                        </select>
                    </span>    
                </div>  
            </div>
            <div id="parentSection" class="form-group">
                <label for="parent" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Parent</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <span id="parentSpan">
                        <%-- <select class="form-control" data-tooltip="<c:out value="${descriptors['editFacilityParentList']}"/>" name="parent" id="parent"> --%>
                        <select class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['editFacilityParentList']}"/>" name="parent" id="parent">
                            <option value="">None</option>
                            <c:forEach items="${results.parentLevel}" var="current">
                                <option value="${current.facilityStation}" <c:if test="${results.parentStation != 'None' && results.parentStation == current.facilityStation}">selected</c:if>>${current.facilityName} (${current.facilityStation})</option>
                            </c:forEach>
                        </select>
                    </span>
                </div>
            </div>       
            <div id="kidsSection" class="form-group">
                <label for="children" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Children</label>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                    <span id="children"></span>
                </div>
            </div>
            <div class="col-sm-offset-2 col-xs-offset-2 col-md-offset-2 col-lg-offset-2 pad-right-10">
                <div class="pad-left-5 checkbox">
                    <%-- <span data-tooltip="<c:out value="${descriptors['editFacilityAllowed']}"/>"> --%>
                    <span class="js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['editFacilityAllowed']}"/>">
                        <label for="allowed" class="control-label">
                            <input type="checkbox" name="allowed" id="allowed" <c:if test="${results.allowed=='Yes'}">checked</c:if> /> Allowed
                        </label>
                    </span>
                </div>
            </div>
            <div class="form-group">
                <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2"></div>
                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4 text-right margin-top-10">
                    <c:if test="${not empty results.stationNumber}">
                    <input disabled="disabled" name="btnInactivate" id="btnInactivate" title="Inactivate Facility (before inactivating a Facility, clear its children and its parent)" type="button" class="btn-danger btn pull-left" value="Inactivate" onclick="inactivateStation()"/>
                    </c:if>
                    <a class="btn btn-default" title="Cancel" href="ViewFacility.do_sec">Cancel</a>
                    <input name="btnSave" id="btnSearch" title="Save" class="btn btn-primary" type="submit" value="Save" />
                </div>
            </div>
        </form>
    </div>
    <div class="modal fade" id="confirmInactivateModal" role="dialog" data-backdrop="static" aria-labelledby="confirmInactivateModalLabel">
        <div class="vertical-alignment-helper">
            <div class="modal-dialog vertical-align-center" role="document">
                <div class="modal-content" tabindex="-1">
                    <div class="modal-header">
                        <h4 class="modal-title" id="confirmInactivateModalLabel">Confirm Inactivation</h4>
                    </div>
                    <div class="modal-body">
                        <p>
                            Are you absolutely sure you want to inactivate <c:out value="${results.facilityName}"/> facility?
                        </p>
                        <p>
                            This facility will be excluded from all reporting and consent management.
                        </p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" id="confirmInactivateModalcancelInactivate" class="btn btn-default" data-dismiss="modal">Cancel</button>
                        <button type="button" id="confirmInactivateModalInactivate" class="btn btn-primary">Inactivate</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>
