<%--
    Document   : optInSummaryReport
    Created on : Dec 4, 2014
    Author     : Irakli Kakushadze
--%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page import="java.util.HashMap"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date" %>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.*" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
%>

<f:mainTemplate headerText="Opt-In Patients Summary Report">
    <script language="JavaScript">
        $(document).ready(function () {
            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');

            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: VAP.common.constructUrl("doSearch"),
                columnDefs: [
                    {className: "text-right", targets: [1, 2, 3]}
                ],
                info: false,
                paging: false,
                processing: true,
                searching: false,
                serverSide: true,
                "footerCallback": function (row, data, start, end, display) {
                    var api = this.api(), data;

                    // Update footers
                    $(api.column(1).footer()).html(
                            api.column(1, {page: 'current'}).data().sum()
                            );
                    $(api.column(2).footer()).html(
                            api.column(2, {page: 'current'}).data().sum()
                            );
                    $(api.column(3).footer()).html(
                            api.column(3, {page: 'current'}).data().sum()
                            );
                }
            });

            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('reportTable');
            });

            $('#searchButton').on('click', function () {
                $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one 
                
                $('#results').show();
                VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load();
            });

            $('#results').hide();
        });
        
        VAP.common.constructUrl = function (methodName) {
            var url = 'OptInSummaryReport.do_sec' +
            '?' + methodName + '=true' +
            '&aggregateAtFacilityLevel=' + facilitiesDialog.getAggregateAtFacilityLevel() +
            '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
            '&patientTypes=' + $('#patientTypes').val() +
            '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
            '&consentType=' +$('#consentType').val() +
             '&enteredBy='+$('#enteredBy').val()+
            '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
            '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];

            return url;
        };
    </script>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12"> 
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div> 
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <form name="searchForm" class="form-horizontal">
                        <jsp:include page="reporting/common/facilitiesFilter.jsp">
                            <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                            <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                            <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                            <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                        </jsp:include>
                        <div class="form-group">
                            <label for="consentType" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Consent Type</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <%-- <select class="form-control" id="consentType" name="consentType" data-tooltip="<c:out value="${descriptors['consentTypeField']}"/>" > --%>
                                <select class="form-control js-simple-tooltip" id="consentType" name="consentType" data-simpletooltip-text="<c:out value="${descriptors['consentTypeField']}"/>" >
                                    <option value="ALL">ALL</option>
                                    <option value="NwHIN Authorization"><c:out value="${organizationName}"/> Authorizations</option>
                                    <option value="SSA Authorization">SSA Authorizations</option>
                                </select>
                            </div>
                        </div>   
                        <div class="form-group"> 
                            <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="enteredBy">Entered By</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <%-- <input class="form-control" title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" data-tooltip="<c:out value="${descriptors['enteredByField']}" />"/> --%>
                                <input class="form-control js-simple-tooltip" title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" data-simpletooltip-text="<c:out value="${descriptors['enteredByField']}" />"/>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <%-- <select class="form-control" id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}" />"> --%>
                                <select class="form-control js-simple-tooltip" id="patientTypes" name="patientTypes" data-simpletooltip-text="<c:out value="${descriptors['patientTypesField']}" />">
                                    <option value="3">ALL</option>
                                    <option value="1" selected>Real Patients</option>
                                    <option value="2">Test Patients</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                                <input name="searchButton" id="searchButton" title="Search" class="btn btn-primary" type="button" value="Search" />
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Search Results" aria-label="Search Results" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right">
                        <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <%-- <th role="columnheader" class="text-center"><span id="authenticatingFacilityHeader" data-tooltip="<c:out value="${descriptors['authenticatingFacilityColumn']}" />">Authenticating Facility</span></th> --%>
                            <%-- <th role="columnheader" class="text-center"><span id="eHealthExchangeAuthorizationHeader" data-tooltip="<c:out value="${descriptors['eHealthExchangeAuthorizationColumn']}" />">eHealth Exchange Authorizations</span></th> --%>
                            <%-- <th role="columnheader" class="text-center"><span id="ssaAuthorizationHeader" data-tooltip="<c:out value="${descriptors['eHealthExchangeSSAAuthorizationColumn']}" />">SSA Authorizations</span></th> --%>
                            <%-- <th role="columnheader" class="text-center"><span id="facilityTotalHeader" data-tooltip="<c:out value="${descriptors['eHealthExchangeAuthorizationProcessedTotal']}" />" data-tooltip-position="left">Facility Total</span></th> --%>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['authenticatingFacilityColumn']}" />"><span id="authenticatingFacilityHeader" data-simpletooltip-target="tableheader">Authenticating Facility</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['eHealthExchangeAuthorizationColumn']}" />"><span id="eHealthExchangeAuthorizationHeader" data-simpletooltip-target="tableheader">eHealth Exchange Authorizations</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary" data-simpletooltip-text="<c:out value="${descriptors['eHealthExchangeSSAAuthorizationColumn']}" />"><span id="ssaAuthorizationHeader" data-simpletooltip-target="tableheader">SSA Authorizations</span></th>
                            <th role="columnheader" class="text-center js-simple-tooltip" data-simpletooltip-prefix-class="secondary-left" data-simpletooltip-text="<c:out value="${descriptors['eHealthExchangeAuthorizationProcessedTotal']}" />"><span id="facilityTotalHeader" data-simpletooltip-target="tableheader">Facility Total</span></th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr role="row">
                            <%--Filled in via Datatables for column totals--%>
                            <td role="gridcell" class="bold text-left">Total:</td>
                            <td role="gridcell" class="bold text-right"></td>
                            <td role="gridcell" class="bold text-right"></td>
                            <td role="gridcell" class="bold text-right"></td>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div> 
    </div>
</f:mainTemplate>