<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<%
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
%>

<f:mainTemplate headerText="Patient Search">
    <script type="text/javascript">
        $(document).ready(function () {
            
        });
    </script>
    
    <c:if test="${not empty message}">
        <div class="alert alert-success alert-dismissible margin-bottom-15 pad-bottom-10 pad-top-10 pad-left-10">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <c:out value="${message}" />
        </div>
    </c:if>
    <cpp:errors />
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Search Criteria" aria-label="Search Criteria" aria-expanded="true" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="patientSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="patientSearchPanel">
                    <div class="alert alert-info">
                        Enter the Social Security number, last name, and first name of the patient for whom you are searching and click Search.
                    </div>
                    <form class="form-horizontal" role="form" id="patientSearchForm" name="patientSearchForm" action="PatientSearch.do_sec" method="POST" data-toggle="validator">
                        <div class="form-group">
                            <label for="ssn" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label"><f:requiredField altText="SSN is a required field." labelText="SSN" /></label>
                            <%--<div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control" id="ssn" name="ssn" maxlength="9" data-tooltip="<c:out value="${descriptors['patientSearchSSNField']}" />" pattern="^\d{9}(,\d{9})*$" required />
                            </div>--%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['patientSearchSSNField']}" />" id="ssn" name="ssn" maxlength="9"  pattern="^\d{9}(,\d{9})*$" required />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="lastName" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label"><f:requiredField altText="Last Name is a required field." labelText="Last Name" /></label>
                            <%--<div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control" id="lastName" name="lastName" maxlength="255" required data-tooltip="<c:out value="${descriptors['patientSearchLastNameField']}" />" required />
                            </div>--%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['patientSearchLastNameField']}" />" id="lastName" name="lastName" maxlength="255" required />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="firstName" class="col-xs-2 col-sm-2 col-md-2 col-lg-1 control-label"><f:requiredField altText="First Name is a required field." labelText="First Name" /></label>
                            <%--<div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control" id="firstName" name="firstName" maxlength="255" required data-tooltip="<c:out value="${descriptors['patientSearchFirstNameField']}" />" required />
                            </div>--%>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                                <input type="text" class="form-control js-simple-tooltip" data-simpletooltip-text="<c:out value="${descriptors['patientSearchFirstNameField']}" />" id="firstName" name="firstName" maxlength="255" required />
                            </div>
                            
                        </div>
                        <div class="form-group">
                            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-4 text-right">
                                <input name="search" title="Search" class="btn btn-primary" type="submit" value="Search" />
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>