<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<script type="text/javascript">
    //restrictions select boxes setup
    var opt2 = new OptionTransfer("revokeList1", "revokeList2");
    opt2.setAutoSort(false);
    opt2.setDelimiter(",");
    opt2.setStaticOptionRegex(new RegExp("^.*?Defense.*?$", "i"));
    opt2.saveNewLeftOptions("newLeft");
    opt2.saveNewRightOptions("newRight");
        
    $(document).ready(function () { 
        $('#signatureDate').datepicker({
            theme: 'vap',
            inputFormat: 'MM/dd/yyyy',
            outputFormat: 'MM/dd/yyyy',
            max: '<c:out value="${today}" />',
            gainFocusOnConstruction: false
        });

        $('#deceasedDate').datepicker({
            theme: 'vap',
            inputFormat: 'MM/dd/yyyy',
            outputFormat: 'MM/dd/yyyy',
            max: '<c:out value="${today}" />',
            gainFocusOnConstruction: false
        });
        
        //call the calendar validation helper tag to remove the error classes for the date inputs and surrounding divs when tabbing/clicking off of the fields
        <date:calendarValidationHelper elementsToRemoveErrorClassesOn="revokeDateAndUploadValidation,signatureDate,revokeDateAndUploadValidationPatientDeceased,deceasedDate" />
        
        opt2.init(document.multiSelectListForm2);
        
        $('#multiSelectListForm2').validator({
            custom: {
                isValidDateMMDDYYYY: function($el) { 
                    var today = moment();
                    var dateToValidate = moment($el.val(), 'MM/DD/YYYY');
                    
                    //return true to denote an error
                    return !moment($el.val(), 'MM/DD/YYYY', true).isValid() || dateToValidate.isAfter(today);
                }
            }
        });
    });
</script>

<div class="alert alert-info">
    <p>
        The Veteran requests and authorizes VA to revoke ALL restrictions
        previously submitted on the release of his/her personal health
        information for treatment purposes to non-VA health care provider
        organizations through ${organizationName}. By revoking all restrictions 
        requests, the sharing of Veteran electronic health information to 
        non-VA health care provider organizations through ${organizationName} 
        is no longer restricted or limited in any way. <br />
    </p>
    <p>
        The VA Form 10-0525 for the revocation of
        Veteran restriction request for sharing of his/her electronic
        health information with non-VA health care provider organizations
        participating in ${organizationName} and partnering with VA for 
        treatment purposes has been validated and verified. The sharing 
        of Veteran electronic health information is no longer restricted 
        or limited in any way.
    </p>
    <p>
        * NOTE: Revoke does not restrict sharing of patient information with DoD, 
        VA patient information is always shared with the DoD.
    </p>
</div>
<div id="revokeRestrictionsErrorMessage" class="alert alert-danger" style="display: none;" role="alert"></div>
<div>
    <form name="multiSelectListForm2" id="multiSelectListForm2" action="PatientDetails.do_sec" method="POST" class="form-horizontal" data-toggle="validator" role="form">
        <input type="hidden" name="icn" value="${patientDemographics.icn}" /> 
        <input type="hidden" name="requestId" value="${requestId}" /> 
        <input type="hidden" name="patientId" value="${consentDirective.patientIen}" /> 
        <input type="hidden" name="consentType" value="NwHIN Organization Restriction Revocation" /> 
        <input type="hidden" name="purposeOfUse" value="TREATMENT" />
        <input type="hidden" name="optOut" value="true" /> <%-- name of the method to call in the servlet on form submit --%> 
        
        <div id="multiSelectRevokeForm" class="pad-bottom-20">
            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                <div class="form-group" id="divList1">
                    <label for="revokeList1" class="control-label">All Providers and Organizations (unrestricted)</label>
                    <div>
                        <select class="listSelect form-control" name="revokeList1" id="revokeList1" multiple size="10">
                            <c:if test="${!empty authorizedOrganizations}">
                                <c:forEach var="r" items="${authorizedOrganizations}" varStatus="i">
                                    <c:choose>
                                        <c:when test="${r.orgNumber eq  '200DOD'}">
                                            <option value="<c:out value="${r.orgNumber}"/>"><c:out value="${r.orgName}"/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
                                        </c:when>
                                        <c:otherwise>
                                            <option value="<c:out value="${r.orgNumber}"/>"><c:out value="${r.orgName}"/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
                                        </c:otherwise>
                                    </c:choose>
                                </c:forEach>
                            </c:if>
                        </select>
                    </div>
                </div>
            </div>
            <div class="col-xs-2 col-sm-2 col-md-2 col-lg-2 text-center pad-top-40">
                <%-- buttons --%>
                <input type="button" class="midButton moveButtons btn btn-primary btn-block btn-sm" name="right" value="Move All &gt;&gt;" alt="Move all the organization to the restriction list" aria-label="Move all the organization to the restriction list" title="Move all the organization to the restriction list" disabled />
                <input type="button" class="midButton moveButtons btn btn-info margin-top-10 btn-block btn-sm" name="right" value="Move Selected &gt;" alt="Move selected organization to the restriction list" aria-label="Move selected organization to the restriction list" title="Move selected organization to the restriction list" disabled />
                <input type="button" class="midButtonLeft moveButtons btn btn-info margin-top-10 btn-block btn-sm" name="left" value="&lt; Move Selected" alt="Remove selected organization from the restriction list" aria-label="Remove selected organization from the restriction list" title="Remove selected organization from the restriction list" disabled />
                <input type="button" class="midButton moveButtons btn btn-default margin-top-10 btn-block btn-sm" name="left" value="Clear" alt="Clear all organizations from the restriction list" aria-label="Clear all organizations from the restriction list" title="Clear all organizations from the restriction list" disabled />
            </div>
            <div class="col-xs-5 col-sm-5 col-md-5 col-lg-5">
                <div class="form-group" id="divList2">
                    <label for="revokeList2" class="control-label"><f:requiredField altText="Providers and Organizations to restrict is a required field." labelText="Providers and Organizations to restrict (restricted)" useNoWrap="false" /></label>
                    <div>
                        <select name="revokeList2" class="listSelect form-control" multiple size="10" id="revokeList2" title="Providers and Organizations to restrict (restricted), Required" aria-label="Providers and Organizations to restrict (restricted), Required">
                            <c:if test="${!empty excludedOrganizations}">
                                <c:forEach var="r" items="${excludedOrganizations}" varStatus="i">
                                    <option value="<c:out value="${r.orgNumber}"/>"><c:out value="${r.orgName}"/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
                                </c:forEach>
                            </c:if>
                        </select>
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <label for="revokeRestrictionsAuthenticatingFacility" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">
                <f:requiredField altText="Authenticating Facility is a required field." labelText="Authenticating Facility" />
            </label> 
            <div class="col-xs-9 col-sm-9 col-md-9 col-lg-9">
                <select id="revokeRestrictionsAuthenticatingFacility" name="userFacility" class="form-control" required>
                    <c:forEach var="f" items="${allowedFacilities}">
                        <option value="<c:out value="${f.facilityStation}"/>"
                            <c:choose>
                                <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                    selected
                                </c:when>
                                <c:when test="${cookie.facility.value == f.facilityStation}">
                                    selected
                                </c:when>
                            </c:choose>>
                            <c:choose>
                                <c:when test="${f.facilityName != ''}">
                                    <c:out value="${f.facilityName}"/>
                                </c:when>
                                <c:otherwise>
                                    <c:out value="${fn:split(f.facilityDns, '.')[0]}"/>
                                </c:otherwise>
                            </c:choose>
                            (<c:out value="${f.facilityStation}"/>)
                        </option>
                    </c:forEach>
                </select> 
            </div>
        </div>
        <div id="revokeForm">
            <div class="form-group">
                <label for="reason" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">
                    <f:requiredField altText="Inactivation Reason is a required field." labelText="Inactivation Reason" />
                </label> 
                <div class="col-xs-9 col-sm-9 col-md-9 col-lg-9">
                    <select id="reason" name="reason" onchange="onOptoutReasonChange(this);" class="form-control" required>
                        <option value="">--Select a reason--</option>
                        <c:if test="${!empty optOutReasons}">
                            <c:forEach var="r" items="${optOutReasons}" varStatus="i">
                                <c:choose>
                                    <c:when test="${r eq 'New Authorization'}">
                                    </c:when>
                                    <c:otherwise>
                                        <option value="<c:out value="${r}"/>"><c:out value="${r}"/></option>
                                    </c:otherwise>
                                </c:choose>
                            </c:forEach>
                        </c:if>
                    </select>
                </div>
            </div>
            <div id="revokeValidationCheckBox" style="display: none;" class="col-xs-offset-3 col-sm-offset-3 col-md-offset-3 col-lg-offset-3">
                <div class="margin-left-10 checkbox form-group pad-bottom-10">
                    <label for="revokeValidationCheckBoxInput">
                        <input type="checkbox" name="revokeValidationCheckBoxInput" value="Revocation Form Received and Validated" id="revokeValidationCheckBoxInput" aria-label="Form Validation for Revocation Form 10-0525 Received and Validated, Required" />
                        <f:requiredField altText="Revocation Form Received and Validatated is a required field." labelText="Form Validation for Revocation Form 10-0525 Received and Validated" /> 
                    </label> 
                </div>
            </div>
            <div class="form-group" id="revokeDateAndUploadValidation" style="display: none;">
                <label for="signatureDate" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label"><f:requiredField altText="Patient Signature Date is a required field." labelText="Patient Signature Date" /></label> 
                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                    <input type="text" name="signatureDate" id="signatureDate" class="form-control vap-datepicker-input" data-isValidDateMMDDYYYY="isValidDateMMDDYYYY" />
                </div>
            </div>
            <div class="form-group" id="revokeDateAndUploadValidationPatientDeceased" style="display: none;">
                <label for="deceasedDate" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label"><f:requiredField altText="Patient Deceased Date is a required field." labelText="Patient Deceased Date" /></label> 
                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                    <input type="text" name="deceasedDate" id="deceasedDate" class="form-control vap-datepicker-input" data-isValidDateMMDDYYYY="isValidDateMMDDYYYY" />
                </div>
            </div>
            <div class="form-group">
                <label for="revokeRestrictionsComments" class="col-xs-3 col-sm-3 col-md-3 col-lg-3 control-label">Comments</label>
                <div class="col-xs-9 col-sm-9 col-md-9 col-lg-9">
                    <textarea id="revokeRestrictionsComments" name="comments" rows="5" class="form-control"></textarea>
                </div>
            </div>
        </div>
    </form>
</div>